/*
 * Kangaroo Punch MultiPlayer Game Server Mark II
 * Copyright (C) 2020-2021  Scott Duensing
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */


#include "comport.h"
#include "timer.h"
#include "task.h"
#include "config.h"


void comPacketSender(char *data, uint32_t length, void *userData) {
	(void)userData;

	comWrite(__configData.serialCom - 1, data, length);
}


int comReceiveBufferFlush(int com) {
	char buffer[256];
	int  result = 1;

	while (result > 0) {
		result = comRead(com, buffer, 255);
	}

	return result;
}


int comWaitWithTimeout(int com, char *buffer, int len, int quarterSeconds, char *expecting) {
	int   r;
	int   quarterTicks  = 0;
	int   count         = 0;
	int   bufferIndex   = 0;
	char  data[2];

	// Returns number of bytes read into buffer.
	// Value is positive if "expect" was found.
	// Value is negative if not found.

	while (quarterTicks <= quarterSeconds) {
		r = comRead(com, data, 1);
		if (r == 1) {
			buffer[bufferIndex++] = data[0];
			buffer[bufferIndex]   = 0;
			if (data[0] == expecting[count]) {
				count++;
				if (count == (int)strlen(expecting)) {
					// Found our expect.
					break;
				}
			} else {
				count = 0;
			}
			if (bufferIndex == len - 1) {
				// Out of buffer.
				break;
			}
		} else {
			taskYield();
			if (__timerQuarterSecondTick) quarterTicks++;
		}
	}

	if (count == (int)strlen(expecting)) {
		return bufferIndex;
	}

	return -bufferIndex;
}
